# std::basic_string< CharT, Traits, Alloc > Class Template Reference
[Containers, Sequences]

Managing sequences of characters and character-like objects. More...

`#include <string>`

Inheritance diagram for std::basic_string< CharT, Traits, Alloc >:

[legend]
List of all members.

## Public Member Functions

| basic_string ()
| Default constructor creates an empty string.
| basic_string (const Alloc &a)
| Construct an empty string using allocator a.
| basic_string (const basic_string &str)
| Construct string with copy of value of str.
| basic_string (const basic_string &str, size_type position, size_type n=npos)
| Construct string as copy of a substring.
| basic_string (const basic_string &str, size_type position, size_type n, const Alloc &a)
| Construct string as copy of a substring.
| basic_string (const CharT *s, size_type n, const Alloc &a=Alloc())
| Construct string initialized by a character array.
| basic_string (const CharT *s, const Alloc &a=Alloc())
| Construct string as copy of a C string.
| basic_string (size_type n, CharT c, const Alloc &a=Alloc())
| Construct string as multiple characters.
template<class InputIterator> | basic_string (InputIterator __beg, InputIterator __end, const Alloc &a=Alloc())
| Construct string as copy of a range.
| ~basic_string ()
| Destroy the string instance.
basic_string & | operator= (const basic_string &str)
| Assign the value of str to this string.
basic_string & | operator= (const CharT *s)
| Copy contents of s into this string.
basic_string & | operator= (CharT c)
| Set value to string of length 1.
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
size_type | size () const
| Returns the number of characters in the string, not including any null-termination.
size_type | length () const
| Returns the number of characters in the string, not including any null-termination.
size_type | max_size () const
| Returns the size() of the largest possible string.
void | resize (size_type n, CharT c)
| Resizes the string to the specified number of characters.
void | resize (size_type n)
| Resizes the string to the specified number of characters.
size_type | capacity () const
void | reserve (size_type __res_arg=0)
| Attempt to preallocate enough memory for specified number of characters.
void | clear ()
bool | empty () const
const_reference | operator[] (size_type position) const
| Subscript access to the data contained in the string.
reference | operator[] (size_type position)
| Subscript access to the data contained in the string.
const_reference | at (size_type n) const
| Provides access to the data contained in the string.
reference | at (size_type n)
| Provides access to the data contained in the string.
basic_string & | operator+= (const basic_string &str)
| Append a string to this string.
basic_string & | operator+= (const CharT *s)
| Append a C string.
basic_string & | operator+= (CharT c)
| Append a character.
basic_string & | append (const basic_string &str)
| Append a string to this string.
basic_string & | append (const basic_string &str, size_type position, size_type n)
| Append a substring.
basic_string & | append (const CharT *s, size_type n)
| Append a C substring.
basic_string & | append (const CharT *s)
| Append a C string.
basic_string & | append (size_type n, CharT c)
| Append multiple characters.
template<class InputIterator> basic_string & | append (InputIterator first, InputIterator last)
| Append a range of characters.
void | push_back (CharT c)
| Append a single character.
basic_string & | assign (const basic_string &str)
| Set value to contents of another string.
basic_string & | assign (const basic_string &str, size_type position, size_type n)
| Set value to a substring of a string.
basic_string & | assign (const CharT *s, size_type n)
| Set value to a C substring.
basic_string & | assign (const CharT *s)
| Set value to contents of a C string.
basic_string & | assign (size_type n, CharT c)
| Set value to multiple characters.
template<class InputIterator> basic_string & | assign (InputIterator first, InputIterator last)
| Set value to a range of characters.
void | insert (iterator __p, size_type n, CharT c)
| Insert multiple characters.
template<class InputIterator> void | insert (iterator __p, InputIterator __beg, InputIterator __end)
| Insert a range of characters.
basic_string & | insert (size_type position1, const basic_string &str)
| Insert value of a string.
basic_string & | insert (size_type position1, const basic_string &str, size_type position2, size_type n)
| Insert a substring.
basic_string & | insert (size_type position, const CharT *s, size_type n)
| Insert a C substring.
basic_string & | insert (size_type position, const CharT *s)
| Insert a C string.
basic_string & | insert (size_type position, size_type n, CharT c)
| Insert multiple characters.
iterator | insert (iterator __p, CharT c)
| Insert one character.
basic_string & | erase (size_type position=0, size_type n=npos)
| Remove characters.
iterator | erase (iterator position)
| Remove one character.
iterator | erase (iterator first, iterator last)
| Remove a range of characters.
basic_string & | replace (size_type position, size_type n, const basic_string &str)
| Replace characters with value from another string.
basic_string & | replace (size_type position1, size_type n1, const basic_string &str, size_type position2, size_type n2)
| Replace characters with value from another string.
basic_string & | replace (size_type position, size_type n1, const CharT *s, size_type n2)
| Replace characters with value of a C substring.
basic_string & | replace (size_type position, size_type n1, const CharT *s)
| Replace characters with value of a C string.
basic_string & | replace (size_type position, size_type n1, size_type n2, CharT c)
| Replace characters with multiple characters.
basic_string & | replace (iterator __i1, iterator __i2, const basic_string &str)
| Replace range of characters with string.
basic_string & | replace (iterator __i1, iterator __i2, const CharT *s, size_type n)
| Replace range of characters with C substring.
basic_string & | replace (iterator __i1, iterator __i2, const CharT *s)
| Replace range of characters with C string.
basic_string & | replace (iterator __i1, iterator __i2, size_type n, CharT c)
| Replace range of characters with multiple characters.
template<class InputIterator> basic_string & | replace (iterator __i1, iterator __i2, InputIterator __k1, InputIterator __k2)
| Replace range of characters with range.
size_type | copy (CharT *s, size_type n, size_type position=0) const
| Copy substring into C string.
void | swap (basic_string &s)
| Swap contents with another string.
const CharT * | c_str () const
| Return const pointer to null-terminated contents.
const CharT * | data () const
| Return const pointer to contents.
allocator_type | get_allocator () const
| Return copy of allocator used to construct this string.
size_type | find (const CharT *s, size_type position, size_type n) const
| Find position of a C substring.
size_type | find (const basic_string &str, size_type position=0) const
| Find position of a string.
size_type | find (const CharT *s, size_type position=0) const
| Find position of a C string.
size_type | find (CharT c, size_type position=0) const
| Find position of a character.
size_type | rfind (const basic_string &str, size_type position=npos) const
| Find last position of a string.
size_type | rfind (const CharT *s, size_type position, size_type n) const
| Find last position of a C substring.
size_type | rfind (const CharT *s, size_type position=npos) const
| Find last position of a C string.
size_type | rfind (CharT c, size_type position=npos) const
| Find last position of a character.
size_type | find_first_of (const basic_string &str, size_type position=0) const
| Find position of a character of string.
size_type | find_first_of (const CharT *s, size_type position, size_type n) const
| Find position of a character of C substring.
size_type | find_first_of (const CharT *s, size_type position=0) const
| Find position of a character of C string.
size_type | find_first_of (CharT c, size_type position=0) const
| Find position of a character.
size_type | find_last_of (const basic_string &str, size_type position=npos) const
| Find last position of a character of string.
size_type | find_last_of (const CharT *s, size_type position, size_type n) const
| Find last position of a character of C substring.
size_type | find_last_of (const CharT *s, size_type position=npos) const
| Find last position of a character of C string.
size_type | find_last_of (CharT c, size_type position=npos) const
| Find last position of a character.
size_type | find_first_not_of (const basic_string &str, size_type position=0) const
| Find position of a character not in string.
size_type | find_first_not_of (const CharT *s, size_type position, size_type n) const
| Find position of a character not in C substring.
size_type | find_first_not_of (const CharT *s, size_type position=0) const
| Find position of a character not in C string.
size_type | find_first_not_of (CharT c, size_type position=0) const
| Find position of a different character.
size_type | find_last_not_of (const basic_string &str, size_type position=npos) const
| Find last position of a character not in string.
size_type | find_last_not_of (const CharT *s, size_type position, size_type n) const
| Find last position of a character not in C substring.
size_type | find_last_not_of (const CharT *s, size_type position=npos) const
| Find position of a character not in C string.
size_type | find_last_not_of (CharT c, size_type position=npos) const
| Find last position of a different character.
basic_string | substr (size_type position=0, size_type n=npos) const
| Get a substring.
int | compare (const basic_string &str) const
| Compare to a string.
int | compare (size_type position, size_type n, const basic_string &str) const
| Compare substring to a string.
int | compare (size_type position1, size_type n1, const basic_string &str, size_type position2, size_type n2) const
| Compare substring to a substring.
int | compare (const CharT *s) const
| Compare to a C string.
int | compare (size_type position, size_type n1, const CharT *s) const
| Compare substring to a C string.
int | compare (size_type position, size_type n1, const CharT *s, size_type n2) const
| Compare substring against a character array.

## Static Public Attributes

const size_type | npos
| Value returned by various member functions when they fail.

## Detailed Description

### template<typename CharT, typename Traits, typename Alloc>
class std::basic_string< CharT, Traits, Alloc >

Managing sequences of characters and character-like objects.

Meets the requirements of a container, a reversible container, and a sequence. Of the optional sequence requirements, only `push_back`, `at`, and array access are supported.

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 111 of file basic_string.h.

## Constructor & Destructor Documentation

template<typename CharT, typename Traits, typename Alloc>
std::basic_string< CharT, Traits, Alloc >::basic_string | ( |  | ) | `[inline]`

| Default constructor creates an empty string. Definition at line 1970 of file basic_string.h. Referenced by std::basic_string< char >::substr().

template<typename CharT, typename Traits, typename Alloc>
std::basic_string< CharT, Traits, Alloc >::basic_string | ( | const Alloc & | a | ) | `[explicit]`

| Construct an empty string using allocator a. Definition at line 188 of file basic_string.tcc.

template<typename CharT, typename Traits, typename Alloc>
std::basic_string< CharT, Traits, Alloc >::basic_string | ( | const basic_string< CharT, Traits, Alloc > & | str | ) |

Construct string with copy of value of str.

Parameters:

  | str | Source string.

Definition at line 180 of file basic_string.tcc.

template<typename CharT, typename Traits, typename Alloc>
std::basic_string< CharT, Traits, Alloc >::basic_string | ( | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position,
|  | size_type | n = `npos`
| ) |

Construct string as copy of a substring.

Parameters:

  | str | Source string.
  | pos | Index of first character to copy from.
  | n | Number of characters to copy (default remainder).

Definition at line 194 of file basic_string.tcc.

template<typename CharT, typename Traits, typename Alloc>
std::basic_string< CharT, Traits, Alloc >::basic_string | ( | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position,
|  | size_type | n,
|  | const Alloc & | a
| ) |

Construct string as copy of a substring.

Parameters:

  | str | Source string.
  | pos | Index of first character to copy from.
  | n | Number of characters to copy.
  | a | Allocator to use.

Definition at line 204 of file basic_string.tcc.

template<typename CharT, typename Traits, typename Alloc>
std::basic_string< CharT, Traits, Alloc >::basic_string | ( | const CharT * | s,
|  | size_type | n,
|  | const Alloc & | a = `Alloc()`
| ) |

Construct string initialized by a character array.

Parameters:

  | s | Source character array.
  | n | Number of characters to copy.
  | a | Allocator to use (default is default allocator).

NB: s must have at least n characters, '' has no special meaning.

Definition at line 216 of file basic_string.tcc.

template<typename CharT, typename Traits, typename Alloc>
std::basic_string< CharT, Traits, Alloc >::basic_string | ( | const CharT * | s,
|  | const Alloc & | a = `Alloc()`
| ) |

Construct string as copy of a C string.

Parameters:

  | s | Source C string.
  | a | Allocator to use (default is default allocator).

Definition at line 223 of file basic_string.tcc.

template<typename CharT, typename Traits, typename Alloc>
std::basic_string< CharT, Traits, Alloc >::basic_string | ( | size_type | n,
|  | CharT | c,
|  | const Alloc & | a = `Alloc()`
| ) |

Construct string as multiple characters.

Parameters:

  | n | Number of characters.
  | c | Character to use.
  | a | Allocator to use (default is default allocator).

Definition at line 230 of file basic_string.tcc.

template<typename CharT, typename Traits, typename Alloc>
template<typename InputIterator>
std::basic_string< CharT, Traits, Alloc >::basic_string | ( | InputIterator | __beg,
|  | InputIterator | __end,
|  | const Alloc & | a = `Alloc()`
| ) |

Construct string as copy of a range.

Parameters:

  | beg | Start of range.
  | end | End of range.
  | a | Allocator to use (default is default allocator).

Definition at line 238 of file basic_string.tcc.

template<typename CharT, typename Traits, typename Alloc>
std::basic_string< CharT, Traits, Alloc >::~basic_string | ( |  | ) | `[inline]`

| Destroy the string instance. Definition at line 414 of file basic_string.h.

## Member Function Documentation

template<typename CharT, typename Traits, typename Alloc>
template<class InputIterator>
basic_string& std::basic_string< CharT, Traits, Alloc >::append | ( | InputIterator | first,
|  | InputIterator | last
| ) | `[inline]`

Append a range of characters.

Parameters:

  | first | Iterator referencing the first character to append.
  | last | Iterator marking the end of the range.

Returns:
  Reference to this string.

Appends characters in the range [first,last) to this string.

Definition at line 774 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::append | ( | size_type | n,
|  | CharT | c
| ) | `[inline]`

Append multiple characters.

Parameters:

  | n | The number of characters to append.
  | c | The character to use.

Returns:
  Reference to this string.

Appends n copies of c to this string.

Definition at line 761 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::append | ( | const CharT * | s | ) | `[inline]`

Append a C string.

Parameters:

  | s | The C string to append.

Returns:
  Reference to this string.

Definition at line 746 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc > & std::basic_string< CharT, Traits, Alloc >::append | ( | const CharT * | s,
|  | size_type | n
| ) |

Append a C substring.

Parameters:

  | s | The C string to append.
  | n | The number of characters to append.

Returns:
  Reference to this string.

Definition at line 629 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::capacity(), std::basic_string< CharT, Traits, Alloc >::reserve(), and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc > & std::basic_string< CharT, Traits, Alloc >::append | ( | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position,
|  | size_type | n
| ) |

Append a substring.

Parameters:

  | str | The string to append.
  | pos | Index of the first character of str to append.
  | n | The number of characters to append.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | if pos is not a valid index.

This function appends n characters from str starting at pos to this string. If n is is larger than the number of available characters in str, the remainder of str is appended.

Definition at line 612 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::capacity(), std::basic_string< CharT, Traits, Alloc >::reserve(), and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc > & std::basic_string< CharT, Traits, Alloc >::append | ( | const basic_string< CharT, Traits, Alloc > & | str | ) |

Append a string to this string.

Parameters:

  | str | The string to append.

Returns:
  Reference to this string.

Definition at line 596 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::capacity(), std::basic_string< CharT, Traits, Alloc >::reserve(), and std::basic_string< CharT, Traits, Alloc >::size().

Referenced by std::collate< CharT >::do_transform(), std::getline(), std::operator+(), std::operator>>(), and std::basic_string< CharT, Traits, Alloc >::resize().

template<typename CharT, typename Traits, typename Alloc>
template<class InputIterator>
basic_string& std::basic_string< CharT, Traits, Alloc >::assign | ( | InputIterator | first,
|  | InputIterator | last
| ) | `[inline]`

Set value to a range of characters.

Parameters:

  | first | Iterator referencing the first character to append.
  | last | Iterator marking the end of the range.

Returns:
  Reference to this string.

Sets value of string to characters in the range [first,last).

Definition at line 863 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::assign | ( | size_type | n,
|  | CharT | c
| ) | `[inline]`

Set value to multiple characters.

Parameters:

  | n | Length of the resulting string.
  | c | The character to use.

Returns:
  Reference to this string.

This function sets the value of this string to n copies of character c.

Definition at line 850 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::assign | ( | const CharT * | s | ) | `[inline]`

Set value to contents of a C string.

Parameters:

  | s | The C string to use.

Returns:
  Reference to this string.

This function sets the value of this string to the value of s. The data is copied, so there is no dependence on s once the function returns.

Definition at line 834 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc > & std::basic_string< CharT, Traits, Alloc >::assign | ( | const CharT * | s,
|  | size_type | n
| ) |

Set value to a C substring.

Parameters:

  | s | The C string to use.
  | n | Number of characters to use.

Returns:
  Reference to this string.

This function sets the value of this string to the first n characters of s. If n is is larger than the number of available characters in s, the remainder of s is used.

Definition at line 261 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::max_size(), and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::assign | ( | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position,
|  | size_type | n
| ) | `[inline]`

Set value to a substring of a string.

Parameters:

  | str | The string to use.
  | pos | Index of the first character of str.
  | n | Number of characters to use.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | if pos is not a valid index.

This function sets this string to the substring of str consisting of n characters at pos. If n is is larger than the number of available characters in str, the remainder of str is used.

Definition at line 806 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc > & std::basic_string< CharT, Traits, Alloc >::assign | ( | const basic_string< CharT, Traits, Alloc > & | str | ) |

Set value to contents of another string.

Parameters:

  | str | Source string to use.

Returns:
  Reference to this string.

Definition at line 245 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::get_allocator().

Referenced by std::money_get< CharT, InIter >::do_get().

template<typename CharT, typename Traits, typename Alloc>
reference std::basic_string< CharT, Traits, Alloc >::at | ( | size_type | n | ) | `[inline]`

Provides access to the data contained in the string.

Parameters:

  | n | The index of the character to access.

Returns:
  Read/write reference to the character.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails. Success results in unsharing the string.

Definition at line 675 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
const_reference std::basic_string< CharT, Traits, Alloc >::at | ( | size_type | n | ) | const`[inline]`

Provides access to the data contained in the string.

Parameters:

  | n | The index of the character to access.

Returns:
  Read-only (const) reference to the character.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 656 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
const_iterator std::basic_string< CharT, Traits, Alloc >::begin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points to the first character in the string. Definition at line 470 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
iterator std::basic_string< CharT, Traits, Alloc >::begin | ( |  | ) | `[inline]`

| Returns a read/write iterator that points to the first character in the string. Unshares the string. Definition at line 459 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
const CharT* std::basic_string< CharT, Traits, Alloc >::c_str | ( |  | ) | const`[inline]`

| Return const pointer to null-terminated contents. This is a handle to internal data. Do not modify or dire things may happen. Definition at line 1453 of file basic_string.h. Referenced by std::money_get< CharT, InIter >::do_get(), std::num_get< CharT, InIter >::do_get(), std::collate< CharT >::do_transform(), std::locale::global(), and std::locale::locale().

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::capacity | ( |  | ) | const`[inline]`

| Returns the total number of characters that the string can hold before needing to allocate more memory. Definition at line 575 of file basic_string.h. Referenced by std::basic_string< CharT, Traits, Alloc >::append(), and std::basic_string< CharT, Traits, Alloc >::reserve().

template<typename CharT, typename Traits, typename Alloc>
void std::basic_string< CharT, Traits, Alloc >::clear | ( |  | ) | `[inline]`

| Erases the string, making it empty. Definition at line 601 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
int std::basic_string< CharT, Traits, Alloc >::compare | ( | size_type | position,
|  | size_type | n1,
|  | const CharT * | s,
|  | size_type | n2
| ) | const

Compare substring against a character array.

Parameters:

  | pos1 | Index of first character of substring.
  | n1 | Number of characters in substring.
  | s | character array to compare against.
  | n2 | Number of characters of s.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n1 characters starting at pos1. Form a string from the first n2 characters of s. Returns an integer < 0 if this substring is ordered before the string from s, 0 if their values are equivalent, or > 0 if this substring is ordered after the string from s. If the lengths of this substring and n2 are different, the shorter one is ordered first. If they are the same, returns the result of traits::compare(substring.data(),s,size());

NB: s must have at least n2 characters, '' has no special meaning.

Definition at line 919 of file basic_string.tcc.

References std::min().

template<typename CharT, typename Traits, typename Alloc>
int std::basic_string< CharT, Traits, Alloc >::compare | ( | size_type | position,
|  | size_type | n1,
|  | const CharT * | s
| ) | const

Compare substring to a C string.

Parameters:

  | pos | Index of first character of substring.
  | n1 | Number of characters in substring.
  | s | C string to compare against.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n1 characters starting at pos. Returns an integer < 0 if the substring is ordered before s, 0 if their values are equivalent, or > 0 if the substring is ordered after s. If the lengths of s and the substring are different, the shorter one is ordered first. If they are the same, returns the result of traits::compare(substring.data(),s,size());

Definition at line 903 of file basic_string.tcc.

References std::min().

template<typename CharT, typename Traits, typename Alloc>
int std::basic_string< CharT, Traits, Alloc >::compare | ( | const CharT * | s | ) | const

Compare to a C string.

Parameters:

  | s | C string to compare against.

Returns:
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before s, 0 if their values are equivalent, or > 0 if this string is ordered after s. If the lengths of s and this string are different, the shorter one is ordered first. If they are the same, returns the result of traits::compare(data(),s,size());

Definition at line 888 of file basic_string.tcc.

References std::min(), and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
int std::basic_string< CharT, Traits, Alloc >::compare | ( | size_type | position1,
|  | size_type | n1,
|  | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position2,
|  | size_type | n2
| ) | const

Compare substring to a substring.

Parameters:

  | pos1 | Index of first character of substring.
  | n1 | Number of characters in substring.
  | str | String to compare against.
  | pos2 | Index of first character of substring of str.
  | n2 | Number of characters in substring of str.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n1 characters starting at pos1. Form the substring of str from the n2 characters starting at pos2. Returns an integer < 0 if this substring is ordered before the substring of str, 0 if their values are equivalent, or > 0 if this substring is ordered after the substring of str. If the lengths of the substring of str and this substring are different, the shorter one is ordered first. If they are the same, returns the result of traits::compare(substring.data(),str.substr(pos2,n2).data(),size());

Definition at line 870 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::data(), and std::min().

template<typename CharT, typename Traits, typename Alloc>
int std::basic_string< CharT, Traits, Alloc >::compare | ( | size_type | position,
|  | size_type | n,
|  | const basic_string< CharT, Traits, Alloc > & | str
| ) | const

Compare substring to a string.

Parameters:

  | pos | Index of first character of substring.
  | n | Number of characters in substring.
  | str | String to compare against.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n characters starting at pos. Returns an integer < 0 if the substring is ordered before str, 0 if their values are equivalent, or > 0 if the substring is ordered after str. If the lengths of str and the substring are different, the shorter one is ordered first. If they are the same, returns the result of traits::compare(substring.data(),str.data(),size());

Definition at line 855 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::data(), std::min(), and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
int std::basic_string< CharT, Traits, Alloc >::compare | ( | const basic_string< CharT, Traits, Alloc > & | str | ) | const`[inline]`

Compare to a string.

Parameters:

  | str | String to compare against.

Returns:
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before str, 0 if their values are equivalent, or > 0 if this string is ordered after str. If the lengths of str and this string are different, the shorter one is ordered first. If they are the same, returns the result of traits::compare(data(),str.data(),size());

Definition at line 1855 of file basic_string.h.

Referenced by std::operator!=(), std::operator<(), std::operator<=(), std::operator==(), std::operator>(), and std::operator>=().

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc >::size_type std::basic_string< CharT, Traits, Alloc >::copy | ( | CharT * | s,
|  | size_type | n,
|  | size_type | position = `0`
| ) | const

Copy substring into C string.

Parameters:

  | s | C string to copy value into.
  | n | Number of characters to copy.
  | pos | Index of first character to copy.

Returns:
  Number of characters actually copied

Exceptions:

  | std::out_of_range | If pos > size().

Copies up to n characters starting at pos into the C string s. If pos is greater than size(), out_of_range is thrown.

Definition at line 671 of file basic_string.tcc.

template<typename CharT, typename Traits, typename Alloc>
const CharT* std::basic_string< CharT, Traits, Alloc >::data | ( |  | ) | const`[inline]`

Return const pointer to contents.

This is a handle to internal data. Do not modify or dire things may happen.

Definition at line 1462 of file basic_string.h.

Referenced by std::basic_string< CharT, Traits, Alloc >::compare(), std::basic_string< char >::compare(), std::money_get< CharT, InIter >::do_get(), std::collate< CharT >::do_transform(), std::basic_string< char >::find(), std::basic_string< char >::find_first_not_of(), std::basic_string< char >::find_first_of(), std::basic_string< char >::find_last_not_of(), std::basic_string< char >::find_last_of(), std::locale::operator()(), and std::basic_string< char >::rfind().

template<typename CharT, typename Traits, typename Alloc>
bool std::basic_string< CharT, Traits, Alloc >::empty | ( |  | ) | const`[inline]`

| Returns true if the string is empty. Equivalent to *this == "". Definition at line 607 of file basic_string.h. Referenced by std::operator>>().

template<typename CharT, typename Traits, typename Alloc>
const_iterator std::basic_string< CharT, Traits, Alloc >::end | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points one past the last character in the string. Definition at line 489 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
iterator std::basic_string< CharT, Traits, Alloc >::end | ( |  | ) | `[inline]`

| Returns a read/write iterator that points one past the last character in the string. Unshares the string. Definition at line 478 of file basic_string.h. Referenced by std::locale::locale().

template<typename CharT, typename Traits, typename Alloc>
iterator std::basic_string< CharT, Traits, Alloc >::erase | ( | iterator | first,
|  | iterator | last
| ) | `[inline]`

Remove a range of characters.

Parameters:

  | first | Iterator referencing the first character to remove.
  | last | Iterator referencing the end of the range.

Returns:
  Iterator referencing location of first after removal.

Removes the characters in the range [first,last) from this string. The value of the string doesn't change if an error is thrown.

Definition at line 1069 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
iterator std::basic_string< CharT, Traits, Alloc >::erase | ( | iterator | position | ) | `[inline]`

Remove one character.

Parameters:

  | position | Iterator referencing the character to remove.

Returns:
  iterator referencing same location after removal.

Removes the character at position from this string. The value of the string doesn't change if an error is thrown.

Definition at line 1049 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::erase | ( | size_type | position = `0`,
|  | size_type | n = `npos`
| ) | `[inline]`

Remove characters.

Parameters:

  | pos | Index of first character to remove (default 0).
  | n | Number of characters to remove (default remainder).

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos is beyond the end of this string.

Removes n characters from this string starting at pos. The length of the string is reduced by n. If there are < n characters to remove, the remainder of the string is truncated. If p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1036 of file basic_string.h.

Referenced by std::getline(), std::locale::locale(), std::operator>>(), and std::basic_string< CharT, Traits, Alloc >::resize().

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc >::size_type std::basic_string< CharT, Traits, Alloc >::find | ( | CharT | c,
|  | size_type | position = `0`
| ) | const

Find position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 699 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::npos, and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::find | ( | const CharT * | s,
|  | size_type | position = `0`
| ) | const`[inline]`

Find position of a C string.

Parameters:

  | s | C string to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of start of first occurrence.

Starting from pos, searches forward for the value of s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1509 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::find | ( | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position = `0`
| ) | const`[inline]`

Find position of a string.

Parameters:

  | str | String to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of start of first occurrence.

Starting from pos, searches forward for value of str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1495 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc >::size_type std::basic_string< CharT, Traits, Alloc >::find | ( | const CharT * | s,
|  | size_type | position,
|  | size_type | n
| ) | const

Find position of a C substring.

Parameters:

  | s | C string to locate.
  | pos | Index of character to search from.
  | n | Number of characters from s to search for.

Returns:
  Index of start of first occurrence.

Starting from pos, searches forward for the first n characters in s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 685 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::npos, and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc >::size_type std::basic_string< CharT, Traits, Alloc >::find_first_not_of | ( | CharT | c,
|  | size_type | position = `0`
| ) | const

Find position of a different character.

Parameters:

  | c | Character to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character other than c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 803 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::npos, and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::find_first_not_of | ( | const CharT * | s,
|  | size_type | position = `0`
| ) | const`[inline]`

Find position of a character not in C string.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character not contained in s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1748 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc >::size_type std::basic_string< CharT, Traits, Alloc >::find_first_not_of | ( | const CharT * | s,
|  | size_type | position,
|  | size_type | n
| ) | const

Find position of a character not in C substring.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search from (default 0).
  | n | Number of characters from s to consider.

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character not contained in the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 791 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::npos, and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::find_first_not_of | ( | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position = `0`
| ) | const`[inline]`

Find position of a character not in string.

Parameters:

  | str | String containing characters to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character not contained in str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1719 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::find_first_of | ( | CharT | c,
|  | size_type | position = `0`
| ) | const`[inline]`

Find position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for the character c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to find(c, pos).

Definition at line 1644 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::find_first_of | ( | const CharT * | s,
|  | size_type | position = `0`
| ) | const`[inline]`

Find position of a character of C string.

Parameters:

  | s | String containing characters to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for one of the characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1625 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc >::size_type std::basic_string< CharT, Traits, Alloc >::find_first_of | ( | const CharT * | s,
|  | size_type | position,
|  | size_type | n
| ) | const

Find position of a character of C substring.

Parameters:

  | s | String containing characters to locate.
  | pos | Index of character to search from (default 0).
  | n | Number of characters from s to search for.

Returns:
  Index of first occurrence.

Starting from pos, searches forward for one of the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 755 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::npos, and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::find_first_of | ( | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position = `0`
| ) | const`[inline]`

Find position of a character of string.

Parameters:

  | str | String containing characters to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for one of the characters of str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1597 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc >::size_type std::basic_string< CharT, Traits, Alloc >::find_last_not_of | ( | CharT | c,
|  | size_type | position = `npos`
| ) | const

Find last position of a different character.

Parameters:

  | c | Character to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches backward for a character other than c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 835 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::npos, and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::find_last_not_of | ( | const CharT * | s,
|  | size_type | position = `npos`
| ) | const`[inline]`

Find position of a character not in C string.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches backward for a character not contained in s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1807 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc >::size_type std::basic_string< CharT, Traits, Alloc >::find_last_not_of | ( | const CharT * | s,
|  | size_type | position,
|  | size_type | n
| ) | const

Find last position of a character not in C substring.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search from (default 0).
  | n | Number of characters from s to consider.

Returns:
  Index of first occurrence.

Starting from pos, searches backward for a character not contained in the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 814 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::npos, and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::find_last_not_of | ( | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position = `npos`
| ) | const`[inline]`

Find last position of a character not in string.

Parameters:

  | str | String containing characters to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches backward for a character not contained in str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1778 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::find_last_of | ( | CharT | c,
|  | size_type | position = `npos`
| ) | const`[inline]`

Find last position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search back from (default 0).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to rfind(c, pos).

Definition at line 1705 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::find_last_of | ( | const CharT * | s,
|  | size_type | position = `npos`
| ) | const`[inline]`

Find last position of a character of C string.

Parameters:

  | s | C string containing characters to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for one of the characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1686 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc >::size_type std::basic_string< CharT, Traits, Alloc >::find_last_of | ( | const CharT * | s,
|  | size_type | position,
|  | size_type | n
| ) | const

Find last position of a character of C substring.

Parameters:

  | s | C string containing characters to locate.
  | pos | Index of character to search back from (default end).
  | n | Number of characters from s to search for.

Returns:
  Index of last occurrence.

Starting from pos, searches backward for one of the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 770 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::npos, and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::find_last_of | ( | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position = `npos`
| ) | const`[inline]`

Find last position of a character of string.

Parameters:

  | str | String containing characters to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for one of the characters of str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1658 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
allocator_type std::basic_string< CharT, Traits, Alloc >::get_allocator | ( |  | ) | const`[inline]`

| Return copy of allocator used to construct this string. Definition at line 1468 of file basic_string.h. Referenced by std::basic_string< CharT, Traits, Alloc >::assign(), std::basic_string< CharT, Traits, Alloc >::reserve(), and std::basic_string< CharT, Traits, Alloc >::swap().

template<typename CharT, typename Traits, typename Alloc>
iterator std::basic_string< CharT, Traits, Alloc >::insert | ( | iterator | __p,
|  | CharT | c
| ) | `[inline]`

Insert one character.

Parameters:

  | p | Iterator referencing position in string to insert at.
  | c | The character to insert.

Returns:
  Iterator referencing newly inserted char.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts character c at position referenced by p. If adding character causes the length to exceed max_size(), length_error is thrown. If p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1012 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::insert | ( | size_type | position,
|  | size_type | n,
|  | CharT | c
| ) | `[inline]`

Insert multiple characters.

Parameters:

  | pos | Index in string to insert at.
  | n | Number of characters to insert
  | c | The character to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos is beyond the end of this string.

Inserts n copies of character c starting at index pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos > length(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 995 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::insert | ( | size_type | position,
|  | const CharT * | s
| ) | `[inline]`

Insert a C string.

Parameters:

  | pos | Iterator referencing location in string to insert at.
  | s | The C string to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos is beyond the end of this string.

Inserts the first n characters of s starting at pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 972 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc > & std::basic_string< CharT, Traits, Alloc >::insert | ( | size_type | position,
|  | const CharT * | s,
|  | size_type | n
| ) |

Insert a C substring.

Parameters:

  | pos | Iterator referencing location in string to insert at.
  | s | The C string to insert.
  | n | The number of characters to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos is beyond the end of this string.

Inserts the first n characters of s starting at pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 287 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::max_size(), and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::insert | ( | size_type | position1,
|  | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position2,
|  | size_type | n
| ) | `[inline]`

Insert a substring.

Parameters:

  | pos1 | Iterator referencing location in string to insert at.
  | str | The string to insert.
  | pos2 | Start of characters in str to insert.
  | n | Number of characters to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos1 > size() or pos2 > str.size().

Starting at pos1, insert n character of str beginning with pos2. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos1 is beyond the end of this string or pos2 is beyond the end of str, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 931 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::insert | ( | size_type | position1,
|  | const basic_string< CharT, Traits, Alloc > & | str
| ) | `[inline]`

Insert value of a string.

Parameters:

  | pos1 | Iterator referencing location in string to insert at.
  | str | The string to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts value of str starting at pos1. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 909 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
template<class InputIterator>
void std::basic_string< CharT, Traits, Alloc >::insert | ( | iterator | __p,
|  | InputIterator | __beg,
|  | InputIterator | __end
| ) | `[inline]`

Insert a range of characters.

Parameters:

  | p | Iterator referencing location in string to insert at.
  | beg | Start of range.
  | end | End of range.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts characters in range [beg,end). If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 894 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
void std::basic_string< CharT, Traits, Alloc >::insert | ( | iterator | __p,
|  | size_type | n,
|  | CharT | c
| ) | `[inline]`

Insert multiple characters.

Parameters:

  | p | Iterator referencing location in string to insert at.
  | n | Number of characters to insert
  | c | The character to insert.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts n copies of character c starting at the position referenced by iterator p. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 879 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::length | ( |  | ) | const`[inline]`

| Returns the number of characters in the string, not including any null-termination. Definition at line 538 of file basic_string.h. Referenced by std::collate< CharT >::do_transform(), and std::locale::operator()().

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::max_size | ( |  | ) | const`[inline]`

Returns the size() of the largest possible string.

Definition at line 542 of file basic_string.h.

Referenced by std::basic_string< CharT, Traits, Alloc >::assign(), std::getline(), std::basic_string< CharT, Traits, Alloc >::insert(), std::operator>>(), std::basic_string< CharT, Traits, Alloc >::replace(), std::basic_string< CharT, Traits, Alloc >::reserve(), and std::basic_string< CharT, Traits, Alloc >::resize().

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::operator+= | ( | CharT | c | ) | `[inline]`

Append a character.

Parameters:

  | s | The character to append.

Returns:
  Reference to this string.

Definition at line 706 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::operator+= | ( | const CharT * | s | ) | `[inline]`

Append a C string.

Parameters:

  | s | The C string to append.

Returns:
  Reference to this string.

Definition at line 698 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::operator+= | ( | const basic_string< CharT, Traits, Alloc > & | str | ) | `[inline]`

Append a string to this string.

Parameters:

  | str | The string to append.

Returns:
  Reference to this string.

Definition at line 690 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::operator= | ( | CharT | c | ) | `[inline]`

Set value to string of length 1.

Parameters:

  | c | Source character.

Assigning to a character makes this string length 1 and (*this)[0] == c.

Definition at line 447 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::operator= | ( | const CharT * | s | ) | `[inline]`

Copy contents of s into this string.

Parameters:

  | s | Source null-terminated string.

Definition at line 433 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::operator= | ( | const basic_string< CharT, Traits, Alloc > & | str | ) | `[inline]`

Assign the value of str to this string.

Parameters:

  | str | Source string.

Definition at line 422 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
reference std::basic_string< CharT, Traits, Alloc >::operator[] | ( | size_type | position | ) | `[inline]`

Subscript access to the data contained in the string.

Parameters:

  | n | The index of the character to access.

Returns:
  Read/write reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().) Unshares the string.

Definition at line 638 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
const_reference std::basic_string< CharT, Traits, Alloc >::operator[] | ( | size_type | position | ) | const`[inline]`

Subscript access to the data contained in the string.

Parameters:

  | n | The index of the character to access.

Returns:
  Read-only (constant) reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 621 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
void std::basic_string< CharT, Traits, Alloc >::push_back | ( | CharT | c | ) | `[inline]`

Append a single character.

Parameters:

  | c | Character to append.

Definition at line 782 of file basic_string.h.

Referenced by std::collate< CharT >::do_transform(), and std::operator>>().

template<typename CharT, typename Traits, typename Alloc>
const_reverse_iterator std::basic_string< CharT, Traits, Alloc >::rbegin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to the last character in the string. Iteration is done in reverse element order. Definition at line 507 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
reverse_iterator std::basic_string< CharT, Traits, Alloc >::rbegin | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to the last character in the string. Iteration is done in reverse element order. Unshares the string. Definition at line 498 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
const_reverse_iterator std::basic_string< CharT, Traits, Alloc >::rend | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order. Definition at line 525 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
reverse_iterator std::basic_string< CharT, Traits, Alloc >::rend | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order. Unshares the string. Definition at line 516 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
template<class InputIterator>
basic_string& std::basic_string< CharT, Traits, Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | InputIterator | __k1,
|  | InputIterator | __k2
| ) | `[inline]`

Replace range of characters with range.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | k1 | Iterator referencing start of range to insert.
  | k2 | Iterator referencing end of range to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, characters in the range [k1,k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1285 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | size_type | n,
|  | CharT | c
| ) | `[inline]`

Replace range of characters with multiple characters.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | n | Number of characters to insert.
  | c | Character to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, n copies of c are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1262 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const CharT * | s
| ) | `[inline]`

Replace range of characters with C string.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | s | C string value to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, the characters of s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1241 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const CharT * | s,
|  | size_type | n
| ) | `[inline]`

Replace range of characters with C substring.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | s | C string value to insert.
  | n | Number of characters from s to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, the first n characters of s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1220 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const basic_string< CharT, Traits, Alloc > & | str
| ) | `[inline]`

Replace range of characters with string.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | str | String value to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, the value of str is inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1202 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::replace | ( | size_type | position,
|  | size_type | n1,
|  | size_type | n2,
|  | CharT | c
| ) | `[inline]`

Replace characters with multiple characters.

Parameters:

  | pos | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | n2 | Number of characters to insert.
  | c | Character to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos > size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, n2 copies of c are inserted. If pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1184 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::replace | ( | size_type | position,
|  | size_type | n1,
|  | const CharT * | s
| ) | `[inline]`

Replace characters with value of a C string.

Parameters:

  | pos | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | str | C string to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos > size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, the first n characters of str are inserted. If pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1161 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc > & std::basic_string< CharT, Traits, Alloc >::replace | ( | size_type | position,
|  | size_type | n1,
|  | const CharT * | s,
|  | size_type | n2
| ) |

Replace characters with value of a C substring.

Parameters:

  | pos | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | str | C string to insert.
  | n2 | Number of characters from str to use.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos1 > size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, the first n2 characters of str are inserted, or all of str if n2 is too large. If pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 322 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::max_size(), and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::replace | ( | size_type | position1,
|  | size_type | n1,
|  | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position2,
|  | size_type | n2
| ) | `[inline]`

Replace characters with value from another string.

Parameters:

  | pos1 | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | str | String to insert.
  | pos2 | Index of first character of str to use.
  | n2 | Number of characters from str to use.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos1 > size() or pos2 > str.size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos1,pos1 + n) from this string. In place, the value of str is inserted. If pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1118 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string& std::basic_string< CharT, Traits, Alloc >::replace | ( | size_type | position,
|  | size_type | n,
|  | const basic_string< CharT, Traits, Alloc > & | str
| ) | `[inline]`

Replace characters with value from another string.

Parameters:

  | pos | Index of first character to replace.
  | n | Number of characters to be replaced.
  | str | String to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos is beyond the end of this string.
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos+n) from this string. In place, the value of str is inserted. If pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1096 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
void std::basic_string< CharT, Traits, Alloc >::reserve | ( | size_type | __res_arg = `0` | ) |

Attempt to preallocate enough memory for specified number of characters.

Parameters:

  | n | Number of characters required.

Exceptions:

  | std::length_error | If n exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

Definition at line 418 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::capacity(), std::basic_string< CharT, Traits, Alloc >::get_allocator(), std::basic_string< CharT, Traits, Alloc >::max_size(), and std::basic_string< CharT, Traits, Alloc >::size().

Referenced by std::basic_string< CharT, Traits, Alloc >::append(), std::num_get< CharT, InIter >::do_get(), std::locale::locale(), std::locale::name(), std::operator+(), and std::operator>>().

template<typename CharT, typename Traits, typename Alloc>
void std::basic_string< CharT, Traits, Alloc >::resize | ( | size_type | n | ) | `[inline]`

Resizes the string to the specified number of characters.

Parameters:

  | n | Number of characters the string should contain.

This function will resize the string to the specified length. If the new size is smaller than the string's current size the string is truncated, otherwise the string is extended and new characters are default-constructed. For basic types such as char, this means setting them to 0.

Definition at line 568 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
void std::basic_string< CharT, Traits, Alloc >::resize | ( | size_type | n,
|  | CharT | c
| ) |

Resizes the string to the specified number of characters.

Parameters:

  | n | Number of characters the string should contain.
  | c | Character to fill any new elements.

This function will resize the string to the specified number of characters. If the number is smaller than the string's current size the string is truncated, otherwise the string is extended and new elements are set to c.

Definition at line 566 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::append(), std::basic_string< CharT, Traits, Alloc >::erase(), std::basic_string< CharT, Traits, Alloc >::max_size(), and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc >::size_type std::basic_string< CharT, Traits, Alloc >::rfind | ( | CharT | c,
|  | size_type | position = `npos`
| ) | const

Find last position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search back from (default 0).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 738 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::npos, and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::rfind | ( | const CharT * | s,
|  | size_type | position = `npos`
| ) | const`[inline]`

Find last position of a C string.

Parameters:

  | s | C string to locate.
  | pos | Index of character to start search at (default 0).

Returns:
  Index of start of last occurrence.

Starting from pos, searches backward for the value of s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1567 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
basic_string< CharT, Traits, Alloc >::size_type std::basic_string< CharT, Traits, Alloc >::rfind | ( | const CharT * | s,
|  | size_type | position,
|  | size_type | n
| ) | const

Find last position of a C substring.

Parameters:

  | s | C string to locate.
  | pos | Index of character to search back from.
  | n | Number of characters from s to search for.

Returns:
  Index of start of last occurrence.

Starting from pos, searches backward for the first n characters in s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 717 of file basic_string.tcc.

References std::min(), std::basic_string< CharT, Traits, Alloc >::npos, and std::basic_string< CharT, Traits, Alloc >::size().

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::rfind | ( | const basic_string< CharT, Traits, Alloc > & | str,
|  | size_type | position = `npos`
| ) | const`[inline]`

Find last position of a string.

Parameters:

  | str | String to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of start of last occurrence.

Starting from pos, searches backward for value of str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1539 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
size_type std::basic_string< CharT, Traits, Alloc >::size | ( |  | ) | const`[inline]`

Returns the number of characters in the string, not including any null-termination.

Definition at line 533 of file basic_string.h.

Referenced by std::basic_string< CharT, Traits, Alloc >::append(), std::basic_string< CharT, Traits, Alloc >::assign(), std::basic_string< char >::at(), std::bitset< Nb >::bitset(), std::basic_string< char >::clear(), std::basic_string< CharT, Traits, Alloc >::compare(), std::basic_string< char >::compare(), std::money_get< CharT, InIter >::do_get(), std::basic_string< CharT, Traits, Alloc >::find(), std::basic_string< char >::find(), std::basic_string< CharT, Traits, Alloc >::find_first_not_of(), std::basic_string< char >::find_first_not_of(), std::basic_string< CharT, Traits, Alloc >::find_first_of(), std::basic_string< char >::find_first_of(), std::basic_string< CharT, Traits, Alloc >::find_last_not_of(), std::basic_string< char >::find_last_not_of(), std::basic_string< CharT, Traits, Alloc >::find_last_of(), std::basic_string< char >::find_last_of(), std::basic_string< CharT, Traits, Alloc >::insert(), std::basic_string< char >::insert(), std::operator+(), std::basic_string< char >::operator[](), std::basic_string< CharT, Traits, Alloc >::replace(), std::basic_string< char >::replace(), std::basic_string< CharT, Traits, Alloc >::reserve(), std::basic_string< CharT, Traits, Alloc >::resize(), std::basic_string< CharT, Traits, Alloc >::rfind(), and std::basic_string< char >::rfind().

template<typename CharT, typename Traits, typename Alloc>
basic_string std::basic_string< CharT, Traits, Alloc >::substr | ( | size_type | position = `0`,
|  | size_type | n = `npos`
| ) | const`[inline]`

Get a substring.

Parameters:

  | pos | Index of first character (default 0).
  | n | Number of characters in substring (default remainder).

Returns:
  The new string.

Exceptions:

  | std::out_of_range | If pos > size().

Construct and return a new string using the n characters starting at pos. If the string is too short, use the remainder of the characters. If pos is beyond the end of the string, out_of_range is thrown.

Definition at line 1839 of file basic_string.h.

template<typename CharT, typename Traits, typename Alloc>
void std::basic_string< CharT, Traits, Alloc >::swap | ( | basic_string< CharT, Traits, Alloc > & | s | ) |

Swap contents with another string.

Parameters:

  | s | String to swap with.

Exchanges the contents of this string with that of s in constant time.

Definition at line 435 of file basic_string.tcc.

References std::basic_string< CharT, Traits, Alloc >::get_allocator().

## Member Data Documentation

template<typename CharT, typename Traits, typename Alloc>
const basic_string< CharT, Traits, Alloc >::size_type std::basic_string< CharT, Traits, Alloc >::npos `[static]`

Value returned by various member functions when they fail.

Definition at line 70 of file basic_string.tcc.

Referenced by std::basic_string< CharT, Traits, Alloc >::find(), std::basic_string< CharT, Traits, Alloc >::find_first_not_of(), std::basic_string< CharT, Traits, Alloc >::find_first_of(), std::basic_string< CharT, Traits, Alloc >::find_last_not_of(), std::basic_string< CharT, Traits, Alloc >::find_last_of(), and std::basic_string< CharT, Traits, Alloc >::rfind().

The documentation for this class was generated from the following files:

- basic_string.h
- basic_string.tcc